﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace MaskSlap
{
    public class vfxmanager : MonoBehaviour
    {
        public static vfxmanager _instance { get; private set; }

        [SerializeField]
        TrailRenderer DashTrail;

        private void Awake()
        {
            _instance = this;
        }

        private void LateUpdate()
        {
            if(DashTrail.enabled)
                DashTrail.transform.position = Player._player.transform.localPosition;
        }

        public void ShowDash()
        {
            DashTrail.Clear();
            DashTrail.enabled = true;
        }
        public void HideDash()
        {
            DashTrail.enabled = false;
        }
    }
}
